package HomeMade.Tracking;


import java.io.File;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
//12
import org.w3c.dom.Document;
import org.w3c.dom.Element;

import ij.*;
import ij.process.*;
import ij.gui.*;
import java.awt.*;
import ij.plugin.*;
import ij.plugin.frame.*;
import ij.macro.*;
import ij.io.*;
import ij.plugin.filter.*;
import ij.WindowManager; //10
import ij.ImageStack; 
import ij.ImagePlus; 
import ij.measure.ResultsTable;
import ij.plugin.PlugIn;
import ij.plugin.filter.PlugInFilter;
import ij.plugin.filter.Analyzer;
import ij.plugin.frame.PlugInFrame;
//33
public class Writetoxml {

static String[] LineColor={"blue", "cyan", "green", "yellow", "orange", "red", "magenta"};
static double oldy;
static double oldx;
static double x;
static double y;
static int d;
static int e;
static int c;
//44
	
	public static void writetoxml(OAindices OAi, ObjectArray OA){
		  try {
	 
			DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
//52	 
			// root element
			Document doc = docBuilder.newDocument();
			Element rootElement = doc.createElement("root");
			doc.appendChild(rootElement);
	 
			// contest element
			Element contest = doc.createElement("TrackContestISBI2012");
			rootElement.appendChild(contest);
//61			 
			// loop through OA and create elements
			for (int i=0; i<OAi.size(0); i++){ // loop through rows
				
				Element particle = doc.createElement("particle");
						oldy=0;
						oldx=0;	
						d=0;		
				for (int j=0; j<OAi.sizeofOAindices; j++){ // loop through cols
					d=j;
					if (OAi.get(j,i)){	
						Element detection = doc.createElement("detection");
						System.out.print(" particle ");
						System.out.print(OAi.getreal(j,i));
						detection.setAttribute("z", "0");
						detection.setAttribute("y", Double.toString(OA.getreal(j,i).y_coord));
						detection.setAttribute("x", Double.toString(OA.getreal(j,i).x_coord));
						detection.setAttribute("t", Integer.toString(j));
//78						
						particle.appendChild(detection);
						
/*
						IJ.run(imp, "RGB Color", "");
						
						while ((d-7)>=0){
						d=d-7;						
						}
						c=d;
						IJ.run("Colors...", "foreground=" + LineColor[c] + " background=orange selection=magenta");
						*/
						if (oldy>0){
						/*
						imp.setSlice(j+1);
						*/
						x=OA.getreal(j,i).x_coord;
						y=OA.getreal(j,i).y_coord;
						/*
						imp.setRoi(new Line(oldx, oldy, x, y));
						for (e=j; e<OAi.sizeofOAindices; e++){
						imp.setSlice(e+1);
						IJ.run(imp, "Draw", "slice");
						}
					
	*/
						oldx=x;
						oldy=y;
						} else {
						oldy=OA.getreal(j,i).y_coord;
						oldx=OA.getreal(j,i).x_coord;

						}
					}	
					

			
				}	
				contest.appendChild(particle);
			}
			 
			// write the content into xml file
			TransformerFactory transformerFactory = TransformerFactory.newInstance();
			Transformer transformer = transformerFactory.newTransformer();
			DOMSource source = new DOMSource(doc);
			StreamResult result = new StreamResult(new File("C:\\Users\\Kasia\\workspace\\Focitracking\\Fusionsnew.xml"));
	 
			// Output to console for testing
			//StreamResult result = new StreamResult(System.out);
	 
			transformer.transform(source, result);
	 
			System.out.println("File saved!");
	 
		  } catch (ParserConfigurationException pce) {
			pce.printStackTrace();
		  } catch (TransformerException tfe) {
			tfe.printStackTrace();
		  }
		}
	}

	
	
	
